'
' RQ GUI ASM TEST AINSTR
' ----------------------
'
DECLARE FUNCTION CallAsmProc LIB "user32" ALIAS "CallWindowProcA" _
            (Proc AS LONG, A1 AS LONG, A2 AS LONG, A3 AS LONG, _
             A4 AS LONG) AS LONG
'
' This Array Is an Assembler Compiled procedure equivalent to
' RQ Function Instr (Start, searchIn, searchFor)
' ============================================================
' ----- START ASM AInstr -----
DefByte AInstrArray (0 To 91) = _
   { _
    &HC8, &H00, &H00, &H00, &H56, &H57, &H8B, &H45, &H08, &H83,  _
    &HF8, &H00, &H0F, &H84, &H01, &H00, &H00, &H00, &H48, &H8B,  _
    &H75, &H0C, &H01, &HC6, &H89, &HF0, &H48, &H40, &H89, &HC6,  _
    &H8B, &H7D, &H10, &H80, &H3E, &H00, &H0F, &H84, &H27, &H00,  _
    &H00, &H00, &HFC, &HA6, &H0F, &H85, &HE9, &HFF, &HFF, &HFF,  _
    &H80, &H3F, &H00, &H0F, &H84, &H0B, &H00, &H00, &H00, &H80,  _
    &H3E, &H00, &H0F, &H84, &H0D, &H00, &H00, &H00, &HEB, &HE5,  _
    &H8B, &H75, &H0C, &H29, &HF0, &H40, &HE9, &H05, &H00, &H00,  _
    &H00, &HB8, &H00, &H00, &H00, &H00, &H5F, &H5E, &HC9, &HC2,  _
    &H10, &H00 _
   }
' ----- END ASM AInstr -----
'
' ----- POINTER to use In CallAsmProc -----
'       A Bit Faster than Calling AInstr
DefInt ptrAInstr
ptrAInstr = VarPtr (AInstrArray(0))
'
' ----- RQ CALL AInstr -----
Function AInstr (Arg1 As Long, Arg2 As Long, Arg3 As Long) As Long
    Result = CallAsmProc (ptrAInstr, Arg1, Arg2, Arg3, 0)
End Function
'
' ============================================================
'
' ============================================================
' ----- START ASM NopSub -----
DefByte NopSubArray (0 To 7) = _
   { _
    &HC8, &H00, &H00, &H00, &HC9, &HC2, &H10, &H00 _
   }
' ----- END ASM NopSub -----
'
' ----- POINTER to use In CallAsmProc -----
'       A Bit Faster than Calling NopSub
DefInt ptrNopSub
ptrNopSub = VarPtr (NopSubArray(0))
'
' ----- RQ CALL NopSub -----
Sub NopSub ()
    DefInt iTmp
    iTmp = CallAsmProc (ptrNopSub, 0, 0, 0, 0)
End Sub
'
' ============================================================
'
' ============================================================
' ----- START ASM NopFunction -----
DefByte NopFunctionArray (0 To 7) = _
   { _
    &HC8, &H00, &H00, &H00, &HC9, &HC2, &H10, &H00 _
   }
' ----- END ASM NopFunction -----
'
' ----- POINTER to use In CallAsmProc -----
'       A Bit Faster than Calling NopFunction
DefInt ptrNopFunction
ptrNopFunction = VarPtr (NopFunctionArray(0))
'
' ----- RQ CALL NopFunction -----
Function NopFunction () As Long
    Result = CallAsmProc (ptrNopFunction, 0, 0, 0, 0)
End Function
'
' ============================================================
'
$ESCAPECHARS ON
$TYPECHECK ON
$INCLUDE "RAPIDQ.INC"
'
DECLARE FUNCTION GetTickCount LIB "kernel32" ALIAS "GetTickCount" AS LONG
'
Declare Sub OnClose_frmAsmTest
Declare Sub OnClic_AnyMenu (Sender As QMenuItem)
Declare Sub TestAsm
Declare Function EmptyRQFunction () as Long
Declare Function GetChrono (sngTimer As Single) As String
'
Sub DummyWndProc
End Sub
Create frmAsmTest As QForm
    Center
    Width = 700
    height = 950
    Caption = "frmAsmTest V 1.0.0 "
    AutoScroll = False
    WndProc = DummyWndProc
    OnClose = OnClose_frmAsmTest
    CREATE rchWin AS QRichEdit  ' will disply the received datas
        Align = 5
        Font.Name = "courier"
        Font.Size = 8
        Font.Color = &HFF0000
        Width = 200
        Height = 200
        ReadOnly = True
        WordWrap = False
        ScrollBars = ssBoth
        HideSelection = False
        PlainText = True
    END CREATE
    CREATE Main AS QMAINMENU
        CREATE mnuRUN AS QMENUITEM
            Caption = "&RUN"
            OnClick = OnClic_AnyMenu
        END CREATE
    END CREATE
End Create
'
Sub OnClose_frmAsmTest
    application.Terminate
    End
End Sub
'
' *************************************
frmAsmTest.ShowModal
' *************************************
'
Sub OnClic_AnyMenu (Sender)
    Select Case Sender.Handle
        Case mnuRun.Handle
            rchWin.Clear
            rchWin.Addstring ("\n     - TEST AInstr ASM Procedure Versus RQ Instr -" & _
                              "\n       =========================================\n")
            TestAsm
            rchWin.Addstring ("\n\n     *** FINISHED\n\nApril 2002")
    End Select
End Sub
'
Function EmptyRQFunction () As Long
End Function
'
Sub TestAsm
    DefInt N, iPtr, iPtr1, iTmp, tEmpty, tInstr, tNopFunction, tAInstr, tCAPNopFunction, tCAPAinstr ' CAP for CallAsmProc
    DefSng tmr, sngTmp
    DefStr sTmp, sTmr
    DefStr searchIn = "dhjsjkdhk lzuieyuyrfqs fjkhkyeui  zyrzeuhfjkh   fui" & _
                        "zeyruizeyrazjkfhsdjkhflqsdhuizey abcdefghijklmnopqrstuvwxyz"
    DefStr searchFor = "xyz"  ' Find at Position = 108
  
    ' Multi Chrono Tests AInstr
    ' =========================
    rchWin.Addstring ("Time Test for 10000 For/Next Loops (in multitasking environnement :)")
    rchWin.Addstring ("----------------------------------")
    ' -------------- RQ EMPTY LOOP  ---------------
    tmr = Timer
    For N = 1 To 10000
    Next N
    sTmr = GetChrono (tmr)
    tEmpty = Val(sTmr)
    rchWin.Addstring (sTmr & " ms for " & Str$(N - 1) & " RQ Loops Empty")
    ' -------------- RQ SINGLE DOEVENTS  ---------------
    tmr = Timer
    For N = 1 To 10000
        DoEvents
    Next N
    sTmr = GetChrono (tmr)
    rchWin.Addstring (sTmr & " ms for " & Str$(N - 1) & " RQ Loops With a single DoEvents")
    ' -------------- RQ LOOP Calling Empty RQ Function ---------------
    tmr = Timer
    For N = 1 To 10000
        iTmp = EmptyRQFunction
    Next N
    sTmr = GetChrono (tmr)
    'tRQEmptyFunction = Val(sTmr)
    rchWin.Addstring (sTmr & " ms for " & Str$(N - 1) & " RQ Loops With a Call To an RQ Empty Function\n")
    ' -------------- RQ NOP ASM SUB  ---------------
    tmr = Timer
    For N = 1 To 10000
        NopSub
    Next N
    sTmr = GetChrono (tmr)
    rchWin.Addstring (sTmr & " ms for " & Str$(N - 1) & " RQ Loops With NOP ASM SUB(*)")
    ' -------------- RQ CallAsmProc NOP ASM SUB  ---------------
    tmr = Timer
    For N = 1 To 10000
        iTmp = CallAsmProc (ptrNopSub, 0, 0, 0, 0)
    Next N
    sTmr = GetChrono (tmr)
    rchWin.Addstring (sTmr & " ms for " & Str$(N - 1) & " RQ Loops With CallAsmProc NOP ASM SUB ")
    ' -------------- RQ NOP ASM FUNCTION  ---------------
    tmr = Timer
    For N = 1 To 10000
        iTmp = NopFunction
    Next N
    sTmr = GetChrono (tmr)
    tNopFunction = Val(sTmr)
    rchWin.Addstring (sTmr & " ms for " & Str$(N - 1) & " RQ Loops With NOP ASM FUNCTION(*)")
    ' -------------- RQ CallAsmProc NOP ASM FUNCTION  ---------------
    tmr = Timer
    For N = 1 To 10000
        iTmp = CallAsmProc (ptrNopFunction, 0, 0, 0, 0)
    Next N
    sTmr = GetChrono (tmr)
    tCAPNopFunction = Val(sTmr)
    rchWin.Addstring (sTmr & " ms for " & Str$(N - 1) & " RQ Loops With CallAsmProc NOP ASM FUNCTION\n")
    ' -------------- ptr to Strings ---------------
    iPtr = VarPtr(searchIn)
    iptr1 = VarPtr(searchFor)
    ' -------------- RQ ASM AINSTR FUNCTION  ---------------
    tmr = Timer
    For N = 1 To 10000
        iTmp = AInstr(1, iPtr, iPtr1)
    Next N
    sTmr = GetChrono (tmr)
    tAInstr = Val(sTmr)
    rchWin.Addstring (sTmr & " ms for " & Str$(N - 1) & " RQ Loops With ASM AInstr search(*)")
    ' -------------- RQ ASM CallAsmProc AINSTR FUNCTION  ---------------
    tmr = Timer
    For N = 1 To 10000
        iTmp = CallAsmProc(ptrAInstr, 1, iPtr, iPtr1, 0)
    Next N
    sTmr = GetChrono (tmr)
    tCAPAInstr = Val(sTmr)
    rchWin.Addstring (sTmr & " ms for " & Str$(N - 1) & " RQ Loops With CallAsmProc AInstr ASM search\n")
    ' -------------- RQ INSTR FUNCTION  ---------------
    tmr = Timer
    For N = 1 To 10000
        iTmp = Instr(1, searchIn, searchFor)
    Next N
    sTmr = GetChrono (tmr)
    tInstr = Val(sTmr)
    rchWin.Addstring (sTmr & " ms for " & Str$(N - 1) & " RQ Loops With RQ Instr search")
    ' -------------- RQ API CALL GetTickCount ----------------
    tmr = Timer
    For N = 1 To 10000
        sngTmp = GetTickCount
    Next N
    sTmr = GetChrono (tmr)
    tInstr = Val(sTmr)
    rchWin.Addstring (sTmr & " ms for " & Str$(N - 1) & " RQ Loops Calling API GetTickCount")
    rchWin.Addstring ("\n   (*)\'NOP ASM SUB\' calls a RQ Sub, calling API CallAsmProc." & _
                      "\n      \'CallAsmProc NOP ASM SUB\' directly calls CallASmProc" & _
                      "\n      Same for NOP ASM FUNCTION" & _
                      "\n      NOP = no operation = Do Nothing, just return" & _
                    "\n\n------------------------------------------------------------------------")
'
'   Times Computations
'   ------------------
    sTmp = "\nTIMES COMPUTATIONS for CALL AINSTR"
    sTmp = sTmp + "\n   AINSTR REAL TIME = AINSTR_TIME - NOPFUNCTION_TIME : " & Str$(tAinstr) & " - " & _
                Str$(tNopFunction) & " = " & Str$(tAinstr - tNopFunction)
    rchWin.Addstring (sTmp)
    sTmp = "\nTIMES COMPUTATIONS for CALLASMPROC (ptrAINstr, ..."
    sTmp = sTmp + "\n   AINSTR REAL TIME = AINSTR_TIME - NOPFUNCTION_TIME : " & Str$(tCAPAinstr) & " - " & _
                Str$(tCAPNopFunction) & " = " & Str$(tCAPAinstr - tCAPNopFunction)
    rchWin.Addstring (sTmp)
    sTmp = "\nTIMES COMPUTATIONS for RQ INSTR"
    sTmp = sTmp + "\n    INSTR REAL TIME = INSTR_TIME - EMPTY_TIME : " & Str$(tinstr) & " - " & _
                Str$(tEmpty) & " = " & Str$(tInstr - tEmpty)

    rchWin.Addstring (sTmp & "\n\n------------------------------------------------------------------------")
    sTmp = "\nCONCLUSION :" & _
           "\n    API CALL CallWindowProc (=CallAsmProc) IN RAPIDQ IS VERY VERY.." & _
           "\n    VERY SLOW...  so slow that there ?may be? a slower somewhere ?" & _
         "\n\n    It\'s useless to write -and call- assembly procedures unless they" & _
           "\n    do a '\long\' repetitive work :) ! RQ adds a header of 40000 CPU" & _
           "\n    tick to call your ASM functions. I tried CallFunc/Bind but it wont" & _
           "\n    Work : after \'Bind ptr To myFunction\' , ptr = 92 (IE)  probably" & _
           "\n    an offset to an internal array... I Still Like Rapid-Q"
    rchWin.Addstring (sTmp)
    exit sub
End Sub
' format chrono in a seven char string aligned right
Function GetChrono (sngTimer As Single) As String
    DefSng tmr
    DefStr sTmr, sTmp1
    tmr = timer - sngTimer
    sTmr = Str$(Int(1000 * tmr))
    sTmp1 = Space$(7)
    sTmr = Replace$ (sTmp1, sTmr, 7 - Len(sTmr))
    Result = sTmr
End Function
'
