'
DECLARE FUNCTION CallAsmProc LIB "user32" ALIAS "CallWindowProcA" _
            (Proc AS LONG, A1 AS LONG, A2 AS LONG, A3 AS LONG, _
             A4 AS LONG) AS LONG
'
' ============================================================
' ----- START ASM GetByteAt -----
DefByte GetByteAtArray (0 To 21) = _
   { _
    &HC8, &H00, &H00, &H00, &H52, &H8B, &H45, &H08, &HBA, &H00,  _
    &H00, &H00, &H00, &H8A, &H10, &H89, &HD0, &H5A, &HC9, &HC2,  _
    &H10, &H00 _
   }
' ----- END ASM GetByteAt -----
'
' ----- POINTER to use In CallAsmProc -----
'       A Bit Faster than Calling GetByteAt
DefInt ptrGetByteAt
ptrGetByteAt = VarPtr (GetByteAtArray(0))
'
' ----- RQ CALL GetByteAt -----
Function GetByteAt (Arg1 As Long) As Long
    Result = CallAsmProc (ptrGetByteAt, Arg1, 0, 0, 0)
End Function
'
' ============================================================
'
' ============================================================
' ----- START ASM GetShortAt -----
DefByte GetShortAtArray (0 To 22) = _
   { _
    &HC8, &H00, &H00, &H00, &H52, &H8B, &H45, &H08, &HBA, &H00,  _
    &H00, &H00, &H00, &H66, &H8B, &H10, &H89, &HD0, &H5A, &HC9,  _
    &HC2, &H10, &H00 _
   }
' ----- END ASM GetShortAt -----
'
' ----- POINTER to use In CallAsmProc -----
'       A Bit Faster than Calling GetShortAt
DefInt ptrGetShortAt
ptrGetShortAt = VarPtr (GetShortAtArray(0))
'
' ----- RQ CALL GetShortAt -----
Function GetShortAt (Arg1 As Long) As Long
    Result = CallAsmProc (ptrGetShortAt, Arg1, 0, 0, 0)
End Function
'
' ============================================================
'
' ============================================================
' ----- START ASM GetLongAt -----
DefByte GetLongAtArray (0 To 21) = _
   { _
    &HC8, &H00, &H00, &H00, &H52, &H8B, &H45, &H08, &HBA, &H00,  _
    &H00, &H00, &H00, &H8B, &H10, &H89, &HD0, &H5A, &HC9, &HC2,  _
    &H10, &H00 _
   }
' ----- END ASM GetLongAt -----
'
' ----- POINTER to use In CallAsmProc -----
'       A Bit Faster than Calling GetLongAt
DefInt ptrGetLongAt
ptrGetLongAt = VarPtr (GetLongAtArray(0))
'
' ----- RQ CALL GetLongAt -----
Function GetLongAt (Arg1 As Long) As Long
    Result = CallAsmProc (ptrGetLongAt, Arg1, 0, 0, 0)
End Function
'
' ============================================================
'
' ============================================================
' ----- START ASM CountChar -----
DefByte CountCharArray (0 To 47) = _
   { _
    &HC8, &H00, &H00, &H00, &H52, &H51, &HB9, &H00, &H00, &H00,  _
    &H00, &H8B, &H45, &H0C, &H88, &HC2, &H8B, &H45, &H08, &H38,  _
    &H10, &H0F, &H85, &H01, &H00, &H00, &H00, &H41, &H80, &H38,  _
    &H00, &H0F, &H84, &H03, &H00, &H00, &H00, &H40, &HEB, &HEB,  _
    &H89, &HC8, &H59, &H5A, &HC9, &HC2, &H10, &H00 _
   }
' ----- END ASM CountChar -----
'
' ----- POINTER to use In CallAsmProc -----
'       A Bit Faster than Calling CountChar
DefInt ptrCountChar
ptrCountChar = VarPtr (CountCharArray(0))
'
' ----- RQ CALL CountChar -----
Function CountChar (Arg1 As Long, Arg2 As Long) As Long
    Result = CallAsmProc (ptrCountChar, Arg1, Arg2, 0, 0)
End Function
'
' ============================================================
'
' ============================================================
' ----- START ASM ReverseString -----
DefByte ReverseStringArray (0 To 60) = _
   { _
    &HC8, &H00, &H00, &H00, &H51, &H56, &H57, &H8B, &H7D, &H0C,  _
    &H8B, &H75, &H08, &HB8, &H00, &H00, &H00, &H00, &HB9, &H00,  _
    &H01, &H00, &H00, &HFC, &HA4, &H40, &H80, &H3E, &H00, &H0F,  _
    &H84, &H02, &H00, &H00, &H00, &HE0, &HF2, &H8B, &H75, &H0C,  _
    &H01, &HC6, &H4E, &H8B, &H7D, &H08, &H89, &HC1, &HFC, &HA4,  _
    &H4E, &H4E, &HE0, &HFA, &H5F, &H5E, &H59, &HC9, &HC2, &H10,  _
    &H00 _
   }
' ----- END ASM ReverseString -----
'
' ----- POINTER to use In CallAsmProc -----
'       A Bit Faster than Calling ReverseString
DefInt ptrReverseString
ptrReverseString = VarPtr (ReverseStringArray(0))
'
' ----- RQ CALL ReverseString -----
Function ReverseString (Arg1 As Long, Arg2 As Long) As Long
    Result = CallAsmProc (ptrReverseString, Arg1, Arg2, 0, 0)
End Function
'
' ============================================================
'
' ============================================================
' ----- START ASM AInstr -----
DefByte AInstrArray (0 To 91) = _
   { _
    &HC8, &H00, &H00, &H00, &H56, &H57, &H8B, &H45, &H08, &H83,  _
    &HF8, &H00, &H0F, &H84, &H01, &H00, &H00, &H00, &H48, &H8B,  _
    &H75, &H0C, &H01, &HC6, &H89, &HF0, &H48, &H40, &H89, &HC6,  _
    &H8B, &H7D, &H10, &H80, &H3E, &H00, &H0F, &H84, &H27, &H00,  _
    &H00, &H00, &HFC, &HA6, &H0F, &H85, &HE9, &HFF, &HFF, &HFF,  _
    &H80, &H3F, &H00, &H0F, &H84, &H0B, &H00, &H00, &H00, &H80,  _
    &H3E, &H00, &H0F, &H84, &H0D, &H00, &H00, &H00, &HEB, &HE5,  _
    &H8B, &H75, &H0C, &H29, &HF0, &H40, &HE9, &H05, &H00, &H00,  _
    &H00, &HB8, &H00, &H00, &H00, &H00, &H5F, &H5E, &HC9, &HC2,  _
    &H10, &H00 _
   }
' ----- END ASM AInstr -----
'
' ----- POINTER to use In CallAsmProc -----
'       A Bit Faster than Calling AInstr
DefInt ptrAInstr
ptrAInstr = VarPtr (AInstrArray(0))
'
' ----- RQ CALL AInstr -----
Function AInstr (Arg1 As Long, Arg2 As Long, Arg3 As Long) As Long
    Result = CallAsmProc (ptrAInstr, Arg1, Arg2, Arg3, 0)
End Function
'
' ============================================================
'
' ============================================================
' ----- START ASM NopFunction -----
DefByte NopFunctionArray (0 To 12) = _
   { _
    &HC8, &H00, &H00, &H00, &HB8, &H2A, &H2C, &H0A, &H00, &HC9,  _
    &HC2, &H10, &H00 _
   }
' ----- END ASM NopFunction -----
'
' ----- POINTER to use In CallAsmProc -----
'       A Bit Faster than Calling NopFunction
DefInt ptrNopFunction
ptrNopFunction = VarPtr (NopFunctionArray(0))
'
' ----- RQ CALL NopFunction -----
Function NopFunction () As Long
    Result = CallAsmProc (ptrNopFunction, 0, 0, 0, 0)
End Function
'
' ============================================================
'
' ============================================================
' ----- START ASM NopSub -----
DefByte NopSubArray (0 To 7) = _
   { _
    &HC8, &H00, &H00, &H00, &HC9, &HC2, &H10, &H00 _
   }
' ----- END ASM NopSub -----
'
' ----- POINTER to use In CallAsmProc -----
'       A Bit Faster than Calling NopSub
DefInt ptrNopSub
ptrNopSub = VarPtr (NopSubArray(0))
'
' ----- RQ CALL NopSub -----
Sub NopSub ()
    DefInt iTmp
    iTmp = CallAsmProc (ptrNopSub, 0, 0, 0, 0)
End Sub
'
' ============================================================
'
' ============================================================
' ----- START ASM Return1234567 -----
DefByte Return1234567Array (0 To 12) = _
   { _
    &HC8, &H00, &H00, &H00, &HB8, &H87, &HD6, &H12, &H00, &HC9,  _
    &HC2, &H10, &H00 _
   }
' ----- END ASM Return1234567 -----
'
' ----- POINTER to use In CallAsmProc -----
'       A Bit Faster than Calling Return1234567
DefInt ptrReturn1234567
ptrReturn1234567 = VarPtr (Return1234567Array(0))
'
' ----- RQ CALL Return1234567 -----
Function Return1234567 () As Long
    Result = CallAsmProc (ptrReturn1234567, 0, 0, 0, 0)
End Function
'
' ============================================================
'
